<?php

class  WPSC_Paybox_Admin_Form {
	private function _description($description) {
		return '<p class="description">'.__($description, 'paybox').'</p>';
	}

	private function _row($label, $control) {
		return '<tr><td>'.$label.'</td><td>'.$control.'</td></tr>';
	}

	public function select($label, $name, array $options, $value, $description) {
		$label = __($label, 'paybox');
		return $this->_row($label, $control, $description);
	}

	public function render(array $wcDef, $prefix, $settings = array()) {
		$output = '';
		foreach ($wcDef as $name => $def) {
			$realName = $prefix.'_'.$name;
			$label = $def['title'];
                        
			$value = isset($settings[$name]) ? $settings[$name] : false;
			if ($value === false) {
				$value = isset($def['default']) ? $def['default'] : null;
			}
			if ($def['type'] == 'title') {
				$output .= '<tr><td colspan="2"><h4>'.$label.'</h4></td></tr>';
			}
			else {
				switch ($def['type']) {
					case 'checkbox':
						$control = '<label><input type="checkbox" name="'.esc_attr($realName).'" value="yes"';
						if ($value == 'yes') {
							$control .= ' checked="checked"';
						}
						$control .= '>'.esc_html($def['label']).'</label>';
						break;
					case 'select':
						$control = '<select name="'.esc_attr($realName).'">';
						foreach ($def['options'] as $k => $v) {
							$control .= '<option value="'.esc_attr($k).'"';
							if ($k == $value) {
								$control .= ' selected="selected"';
							}
							$control .= '>'.esc_html($v).'</option>';
						}
						$control .= '</select>';
						break;
					case 'text':
						$control = '<input type="text" name="'.esc_attr($realName).'"';
						if (!is_null($value)) {
							$control .= ' value="'.esc_attr($value).'"';
						}
						$control .= '/>';
						break;
					case 'textarea':
						$control = '<textarea name="'.esc_attr($realName).'">';
						if (!is_null($value)) {
							$control .= esc_html($value);
						}
						$control .= '</textarea>';
						break;
					default:
						throw new Exception('Unknown type '.$def['type']);
				}
				if (isset($def['description'])) {
					$control .= $this->_description($def['description']);
				}
				$output .= $this->_row($label, $control);
			}
		}
		return $output;
	}
}